###################################################
### chunk number 1: 
###################################################
#line 23 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
library(sampling)
ps.options(pointsize=12)
options(width=60)



###################################################
### chunk number 2: up1
###################################################
#line 62 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
data(belgianmunicipalities)
attach(belgianmunicipalities)
# sample size
n=20
pik=inclusionprobabilities(Tot04,n)
N=length(pik)




###################################################
### chunk number 3: up2
###################################################
#line 74 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
sim=10
ss=ss1=array(0,c(sim,4))



###################################################
### chunk number 4: up3
###################################################
#line 81 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
cat("Case 1\n")
y1=rep(3,N)
cat("Case 2\n")
y2=TaxableIncome
cat("Case 3\n")
x=1:N
pik3=inclusionprobabilities(x,n)
y3=1/pik3
cat("Case 4\n")
epsilon=rnorm(N,0,sqrt(1/3))
pik4=pik3
y4=5*(x+epsilon)



###################################################
### chunk number 5: up4
###################################################
#line 98 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
ht=numeric(4)
hajek=numeric(4)
for(i in 1:sim)
{
cat("Simulation ",i,"\n")
cat("Case 1\n")
s=UPtille(pik)
ht[1]=HTestimator(y1[s==1],pik[s==1])
hajek[1]=Hajekestimator(y1[s==1],pik[s==1],N,type="total")
cat("Case 2\n")
s1=UPpoisson(pik)
ht[2]=HTestimator(y2[s1==1],pik[s1==1])
hajek[2]=Hajekestimator(y2[s1==1],pik[s1==1],N,type="total")
cat("Case 3\n")
ht[3]=HTestimator(y3[s==1],pik3[s==1])
hajek[3]=Hajekestimator(y3[s==1],pik3[s==1],N,type="total")
cat("Case 4\n")
ht[4]=HTestimator(y4[s==1],pik4[s==1])
hajek[4]=Hajekestimator(y4[s==1],pik4[s==1],N,type="total")
ss[i,]=ht
ss1[i,]=hajek
}




###################################################
### chunk number 6: up5
###################################################
#line 126 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
#true values
tv=c(sum(y1),sum(y2),sum(y3),sum(y4))
for(i in 1:4)
{
cat("Case ",i,"\n")
cat("The Horvitz-Thompson estimator under simulations:",mean(ss[,i])," and the true value:",tv[i],"\n") 
MSE1=var(ss[,i])+(mean(ss[,i])-tv[i])^2
cat("MSE Horvitz-Thompson estimator:",MSE1,"\n")
cat("The Hajek estimator under simulations:",mean(ss1[,i])," and the true value:",tv[i],"\n") 
MSE2=var(ss1[,i])+(mean(ss1[,i])-tv[i])^2
cat("MSE Hajek estimator:",MSE2,"\n")
cat("Ratio of the two MSE:", MSE1/MSE2,"\n")
}



###################################################
### chunk number 7:  eval=FALSE
###################################################
## #line 141 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
## #line 62 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw#from line#141#"
## data(belgianmunicipalities)
## attach(belgianmunicipalities)
## # sample size
## n=20
## pik=inclusionprobabilities(Tot04,n)
## N=length(pik)
## 
## 
## #line 142 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
## #line 74 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw#from line#142#"
## sim=10
## ss=ss1=array(0,c(sim,4))
## 
## #line 143 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
## #line 81 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw#from line#143#"
## cat("Case 1\n")
## y1=rep(3,N)
## cat("Case 2\n")
## y2=TaxableIncome
## cat("Case 3\n")
## x=1:N
## pik3=inclusionprobabilities(x,n)
## y3=1/pik3
## cat("Case 4\n")
## epsilon=rnorm(N,0,sqrt(1/3))
## pik4=pik3
## y4=5*(x+epsilon)
## 
## #line 144 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
## #line 98 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw#from line#144#"
## ht=numeric(4)
## hajek=numeric(4)
## for(i in 1:sim)
## {
## cat("Simulation ",i,"\n")
## cat("Case 1\n")
## s=UPtille(pik)
## ht[1]=HTestimator(y1[s==1],pik[s==1])
## hajek[1]=Hajekestimator(y1[s==1],pik[s==1],N,type="total")
## cat("Case 2\n")
## s1=UPpoisson(pik)
## ht[2]=HTestimator(y2[s1==1],pik[s1==1])
## hajek[2]=Hajekestimator(y2[s1==1],pik[s1==1],N,type="total")
## cat("Case 3\n")
## ht[3]=HTestimator(y3[s==1],pik3[s==1])
## hajek[3]=Hajekestimator(y3[s==1],pik3[s==1],N,type="total")
## cat("Case 4\n")
## ht[4]=HTestimator(y4[s==1],pik4[s==1])
## hajek[4]=Hajekestimator(y4[s==1],pik4[s==1],N,type="total")
## ss[i,]=ht
## ss1[i,]=hajek
## }
## 
## 
## #line 145 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
## #line 126 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw#from line#145#"
## #true values
## tv=c(sum(y1),sum(y2),sum(y3),sum(y4))
## for(i in 1:4)
## {
## cat("Case ",i,"\n")
## cat("The Horvitz-Thompson estimator under simulations:",mean(ss[,i])," and the true value:",tv[i],"\n") 
## MSE1=var(ss[,i])+(mean(ss[,i])-tv[i])^2
## cat("MSE Horvitz-Thompson estimator:",MSE1,"\n")
## cat("The Hajek estimator under simulations:",mean(ss1[,i])," and the true value:",tv[i],"\n") 
## MSE2=var(ss1[,i])+(mean(ss1[,i])-tv[i])^2
## cat("MSE Hajek estimator:",MSE2,"\n")
## cat("Ratio of the two MSE:", MSE1/MSE2,"\n")
## }
## 
## #line 146 "d:/Rcompile/CRANpkg/local/2.12/sampling/inst/doc/HT_Hajek_estimators.Snw"
## 
## 
## sampling.newpage()
## 


